package com.bonus.material.toolProcess.mapper;

import com.bonus.material.tool.domain.ToolEntity;
import com.bonus.material.toolProcess.domain.ToolApplyDetailsEntity;
import com.bonus.material.toolProcess.domain.ToolApplyEntity;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface ToolApplyMapper {
    /**
     * 工具申请单表格
     *
     * @param entity 实体
     * @return 表格
     */
    List<ToolApplyEntity> list(ToolApplyEntity entity);

    /**
     * 工具录入删除
     *
     * @param entity 实体
     * @return 结果
     */
    Integer delete(ToolApplyEntity entity);

    /**
     * 工具录入订单删除
     *
     * @param entity 实体
     * @return 结果
     */
    Integer deleteDetail(ToolApplyDetailsEntity entity);

    /**
     * 新增订单
     *
     * @param entity 实体
     * @return 结果
     */
    Integer add(ToolApplyEntity entity);

    /**
     * 新增设备详情
     *
     * @param entity 实体
     * @return 结果
     */

    Integer addDetail(ToolApplyDetailsEntity entity);

    /**
     * 工具录入申请单表格
     *
     * @param entity 实体
     * @return 表格
     */
    List<ToolApplyDetailsEntity> listByApplyId(ToolApplyDetailsEntity entity);

    /**
     * 获取下拉选
     *
     * @param entity 实体
     * @return 集合
     */

    List<ToolEntity> getTreeSelect(ToolEntity entity);

    /**
     * 修改订单状态
     *
     * @param entity 条件
     * @return 条数
     */

    Integer update(ToolApplyEntity entity);

    /**
     * 修改订单装备状态
     *
     * @param entity 条件
     * @return 条数
     */
    Integer updateDetail(ToolApplyDetailsEntity entity);

    /**
     * 修改订单装备状态
     *
     * @param entity 条件
     * @return 条数
     */
    Integer updateAllDetail(ToolApplyDetailsEntity entity);

    /**
     * 获取审核列表
     *
     * @param entity 实体
     * @return 集合
     */
    List<ToolApplyEntity> listReview(ToolApplyEntity entity);

    /**
     * 获取未审批的数量
     *
     * @param applyId
     * @return
     */
    Integer getCount(Long applyId);

    List<ToolApplyDetailsEntity> listEncoding(ToolApplyDetailsEntity entity);

    /**
     * 获取审核的数据
     *
     * @param entity
     * @return
     */
    // 查询要修改的 ID 列表
    List<Long> selectDetailIdsByCondition(ToolApplyDetailsEntity entity);

    List<Long> selectAllDetailIdsByApplyId(ToolApplyDetailsEntity entity);

    List<ToolApplyDetailsEntity> listById(@Param("ids") List<Long> ids);

    Integer deleteTool(Integer id);

    List<ToolApplyDetailsEntity> listWarehousingToolByApplyId(ToolApplyDetailsEntity entity);

    void updateByToolId(ToolApplyDetailsEntity item);
}
